Coin: SoEngineOutputData Class Reference

| Coin3D is Free Software, published under the BSD 3-clause license. | https://coin3d.github.io https://www.kongsberg.com/en/kogt/

SoEngineOutputData Class Reference
Engine Classes

The SoEngineOutputData class is a container for a prototype set of outputs. More...

`#include <Inventor/engines/SoOutputData.h>`

## Public Member Functions
| SoEngineOutputData (void)
| SoEngineOutputData (const SoEngineOutputData *data)
| SoEngineOutputData (int approxnum)
| ~SoEngineOutputData (void)
void | addOutput (const SoEngine *base, const char *name, const SoEngineOutput *output, SoType type)
void | addOutput (const SoNodeEngine *base, const char *name, const SoEngineOutput *output, SoType type)
int | getNumOutputs (void) const
const SbName & | getOutputName (int index) const
SoEngineOutput * | getOutput (const SoEngine *engine, int index) const
SoEngineOutput * | getOutput (const SoNodeEngine *engine, int index) const
int | getIndex (const SoEngine *engine, const SoEngineOutput *output) const
int | getIndex (const SoNodeEngine *engine, const SoEngineOutput *output) const
const SoType & | getType (int index) const
SbBool | readDescriptions (SoInput *input, SoEngine *engine) const
void | writeDescriptions (SoOutput *out, SoEngine *engine) const

## Detailed Description

The SoEngineOutputData class is a container for a prototype set of outputs.

This class is instantiated once for each class of objects which use outputs, and which need to be able to import and export them.

Each output of a class is stored with the name and type it has been given within its "owner" class and a pointer offset to the dynamic instance of the output itself.

It is unlikely that application programmers should need to use any of the methods of this class directly.

## Constructor & Destructor Documentation

## ◆ SoEngineOutputData() [1/3]

SoEngineOutputData::SoEngineOutputData | ( | void |  | ) |

Constructor.

## ◆ SoEngineOutputData() [2/3]

SoEngineOutputData::SoEngineOutputData | ( | const SoEngineOutputData * | data | ) |

Copy constructor.

## ◆ SoEngineOutputData() [3/3]

SoEngineOutputData::SoEngineOutputData | ( | int | approxnum | ) |

Constructor. Supply the approximated number of outputs in the engine to optimize memory allocation.

## ◆ ~SoEngineOutputData()

SoEngineOutputData::~SoEngineOutputData | ( | void |  | ) |

Destructor.

## Member Function Documentation

## ◆ addOutput() [1/2]

void SoEngineOutputData::addOutput | ( | const SoEngine * | base,
|  | const char * | name,
|  | const SoEngineOutput * | output,
|  | SoType | type )

Add a new output to our internal list.

The name and type will be stored along with a pointer offset between base and output, which will be valid for all instances of the class type of base.

## ◆ addOutput() [2/2]

void SoEngineOutputData::addOutput | ( | const SoNodeEngine * | base,
|  | const char * | name,
|  | const SoEngineOutput * | output,
|  | SoType | type )

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## ◆ getNumOutputs()

int SoEngineOutputData::getNumOutputs | ( | void |  | ) | const

Returns the number of outputs contained within this instance.

## ◆ getOutputName()

const SbName & SoEngineOutputData::getOutputName | ( | int | index | ) | const

Returns the name of the output at index.

## ◆ getOutput() [1/2]

SoEngineOutput * SoEngineOutputData::getOutput | ( | const SoEngine * | engine,
|  | int | index ) const

Returns a pointer to the output at index within the engine instance.

## ◆ getOutput() [2/2]

SoEngineOutput * SoEngineOutputData::getOutput | ( | const SoNodeEngine * | engine,
|  | int | index ) const

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## ◆ getIndex() [1/2]

int SoEngineOutputData::getIndex | ( | const SoEngine * | engine,
|  | const SoEngineOutput * | output ) const

Returns the internal index value of output in engine. If output is not part of engine, it returns -1.

## ◆ getIndex() [2/2]

int SoEngineOutputData::getIndex | ( | const SoNodeEngine * | engine,
|  | const SoEngineOutput * | output ) const

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## ◆ getType()

const SoType & SoEngineOutputData::getType | ( | int | index | ) | const

Returns the type of the output at index.

## ◆ readDescriptions()

SbBool SoEngineOutputData::readDescriptions | ( | SoInput * | in,
|  | SoEngine * | engine ) const

FIXME: doc

The documentation for this class was generated from the following files:

- SoOutputData.h
- SoOutputData.cpp